﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace CSharpCode
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class MutableAccount
    {
        public class Account
        {
            public Account(decimal balance)
            {
                Balance = balance;
            }

            public decimal Balance { get; set; }
        }

        private void ReceivePayCheck(Account account)
        {
            account.Balance += 1000;
        }

        private void PayBills(Account account)
        {
            if (account.Balance < 700)
                throw new ArgumentException("Insufficent funds to pay bills", "account");

            account.Balance -= 700;
        }

        [TestMethod]
        public void PayCheckFirst()
        {
            //this works fine
            var account = new Account(100);

            ReceivePayCheck(account);
            PayBills(account);
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentException))]
        public void BillsFirst()
        {
            //but this raises an ArgumentException
            var account = new Account(100);

            PayBills(account);
            ReceivePayCheck(account);
        }
    }
}
